//
//  PSC.java
//
//  Salvador Garca Lpez
//
//  Created by Salvador Garca Lpez 4-3-2009.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

package keel.Algorithms.Preprocess.Instance_Selection.PSC;

import keel.Algorithms.Preprocess.Basic.*;
import org.core.*;
import java.util.StringTokenizer;
import java.util.Vector;
import java.util.Arrays;

public class PSC extends Metodo {
	
	/*Parameters of the algorithm*/
	private int C;
	private long seed;

	public PSC (String ficheroScript) {
		super (ficheroScript);
	}

	public void ejecutar () {

		int i, j, k, l;
		int nClases;
		boolean marcas[];
		int nSel = 0;
		double conjS[][];
		double conjR[][];
		int conjN[][];
		boolean conjM[][];
		int clasesS[];
		int clusters[];
		double centers[][];
		double dist, minDist;
		int pos, max;
		int majorityClass[];
		int mClass;
		int Pc;

		long tiempo = System.currentTimeMillis();

		/*Getting the number of differents classes*/
		nClases = 0;
		for (i = 0; i < clasesTrain.length; i++)
			if (clasesTrain[i] > nClases)
				nClases = clasesTrain[i];
		nClases++;
		
		Randomize.setSeed(seed);
		
		marcas = new boolean[datosTrain.length];
		Arrays.fill(marcas, false);
		centers = new double[C][datosTrain[0].length];
		
		clusters = Cmeans(datosTrain, C, centers);
		
		majorityClass = new int[nClases];
		for (i=0; i<C; i++) {
			if (isHomogeneous(i,clusters,clasesTrain)) {				
				minDist = Double.POSITIVE_INFINITY;
				pos = 0;
				for (j=0; j<datosTrain.length; j++) {
					if (clusters[j] == i) {
						dist = KNN.distancia(datosTrain[j], centers[i]);
						if (dist < minDist) {
							minDist = dist;
							pos = j;
						}
					}
				}
				marcas[pos] = true;
				nSel++;
			} else {
				Arrays.fill(majorityClass, 0);
				for (j=0; j<datosTrain.length; j++) {
					if (clusters[j] == i) {
						majorityClass[clasesTrain[j]]++;
					}
				}
				
				max = majorityClass[0];
				pos = 0;
				for (j=1; j<nClases; j++) {
					if (majorityClass[j] > max) {
						max = majorityClass[j];
						pos = j;
					}
				}
				mClass = pos;
				
				for (j=0; j<datosTrain.length; j++) {
					if (clusters[j] == i) {
						if (clasesTrain[j] != mClass) {
							minDist = Double.POSITIVE_INFINITY;
							pos = 0;
							for (k=0; k<datosTrain.length; k++) {
								if (clusters[k] == i) {
									if (clasesTrain[k] == mClass) {
										dist = KNN.distancia(datosTrain[k], datosTrain[j]);
										if (dist < minDist) {
											minDist = dist;
											pos = k;
										}
									}
								}
							}
							if (!marcas[pos]) {
								marcas[pos] = true;
								nSel++;								
							}
							Pc = pos;

							minDist = Double.POSITIVE_INFINITY;
							pos = 0;
							for (k=0; k<datosTrain.length; k++) {
								if (clusters[k] == i) {
									if (clasesTrain[k] == clasesTrain[j]) {
										dist = KNN.distancia(datosTrain[k], datosTrain[Pc]);
										if (dist < minDist) {
											minDist = dist;
											pos = k;
										}
									}
								}
							}
							if (!marcas[pos]) {
								marcas[pos] = true;
								nSel++;								
							}
						}
					}
				}
			}
		}


		/*Building of the S set from the flags*/
		conjS = new double[nSel][datosTrain[0].length];
		conjR = new double[nSel][datosTrain[0].length];
		conjN = new int[nSel][datosTrain[0].length];
		conjM = new boolean[nSel][datosTrain[0].length];
		clasesS = new int[nSel];
		for (i=0, l=0; i<datosTrain.length; i++) {
			if (marcas[i]) { //the instance will be copied to the solution
				for (j=0; j<datosTrain[0].length; j++) {
					conjS[l][j] = datosTrain[i][j];
					conjR[l][j] = realTrain[i][j];
					conjN[l][j] = nominalTrain[i][j];
					conjM[l][j] = nulosTrain[i][j];
				}
				clasesS[l] = clasesTrain[i];
				l++;
			}
		}

		System.out.println("PSC "+ relation + " " + (double)(System.currentTimeMillis()-tiempo)/1000.0 + "s");

		OutputIS.escribeSalida(ficheroSalida[0], conjR, conjN, conjM, clasesS, entradas, salida, nEntradas, relation);
		OutputIS.escribeSalida(ficheroSalida[1], test, entradas, salida, nEntradas, relation);
	}
	
	private int[] Cmeans (double datosTrain[][], int C, double centers[][]) {

		int clusters[];
		int tmp, pos;
		int baraje[];
		int i, j;
		double minDist, dist;
		boolean cambio = true;
		int nc[];
		
		clusters = new int[datosTrain.length];
		baraje = new int[datosTrain.length];
		
		for (i=0; i<datosTrain.length; i++) {
			baraje[i] = i;
		}

		for (i=0; i<datosTrain.length; i++) {
			pos = Randomize.Randint(i, datosTrain.length);
			tmp = baraje[i];
			baraje[i] = baraje[pos];
			baraje[pos] = tmp;			
		}
		
		for (i=0; i<C; i++) {
			for (j=0; j<datosTrain[0].length; j++) {
				centers[i][j] = datosTrain[baraje[i]][j];
			}
		}
		
		for (i=0; i<datosTrain.length; i++) {
			pos = 0;
			minDist = KNN.distancia(datosTrain[i], centers[0]);
			for (j=1; j<C; j++) {
				dist = KNN.distancia(datosTrain[i], centers[j]);
				if (dist < minDist) {
					pos = j;
					minDist = dist;
				}
			}
			clusters[i] = pos;
		}
		
		nc = new int[C];
		while (cambio) {
			cambio = false;
			
			Arrays.fill(nc, 0);
			for (i=0; i<C; i++) {
				Arrays.fill(centers[i], 0.0);
			}
			
			for (i=0; i<datosTrain.length; i++) {
				nc[clusters[i]]++;
				for (j=0; j<datosTrain[0].length; j++) {
					centers[clusters[i]][j] += datosTrain[i][j];
				}
			}
			
			for (i=0; i<C; i++) {
				for (j=0; j<datosTrain[0].length; j++) {
					centers[i][j] /= (double)nc[i];
				}
			}
			
			for (i=0; i<datosTrain.length; i++) {
				pos = 0;
				minDist = KNN.distancia(datosTrain[i], centers[0]);
				for (j=1; j<C; j++) {
					dist = KNN.distancia(datosTrain[i], centers[j]);
					if (dist < minDist) {
						pos = j;
						minDist = dist;
					}
				}
				if (clusters[i] != pos) {
					cambio = true;
					clusters[i] = pos;
				}
			}
			
		}

		return clusters;
	}
	
	boolean isHomogeneous(int pos, int clusters[], int clasesTrain[]) {
		
		int i;
		boolean stop = false;
		int classD = 0;
		
		for (i=0; i<clasesTrain.length && !stop; i++) {
			if (clusters[i] == pos) {
				classD = clasesTrain[i];
				stop = true;
			}
		}
		
		for ( ; i<clasesTrain.length; i++) {
			if (clusters[i] == pos && clasesTrain[i] != classD) {
				return false;
			}
		}
		
		return true;
	}

    public void leerConfiguracion (String ficheroScript) {

    	String fichero, linea, token;
    	StringTokenizer lineasFichero, tokens;
    	byte line[];
    	int i, j;

    	ficheroSalida = new String[2];

    	fichero = Fichero.leeFichero (ficheroScript);
    	lineasFichero = new StringTokenizer (fichero,"\n\r");

    	lineasFichero.nextToken();
    	linea = lineasFichero.nextToken();

    	tokens = new StringTokenizer (linea, "=");
    	tokens.nextToken();
    	token = tokens.nextToken();

    	/*Getting the names of the training and test files*/
    	line = token.getBytes();
    	for (i=0; line[i]!='\"'; i++);
    	i++;
    	for (j=i; line[j]!='\"'; j++);
    	ficheroTraining = new String (line,i,j-i);
    	for (i=j+1; line[i]!='\"'; i++);
    	i++;
    	for (j=i; line[j]!='\"'; j++);
    	ficheroTest = new String (line,i,j-i);

    	/*Getting the path and base name of the results files*/
    	linea = lineasFichero.nextToken();
    	tokens = new StringTokenizer (linea, "=");
    	tokens.nextToken();
    	token = tokens.nextToken();

    	/*Getting the names of output files*/
    	line = token.getBytes();
    	for (i=0; line[i]!='\"'; i++);
    	i++;
    	for (j=i; line[j]!='\"'; j++);
    	ficheroSalida[0] = new String (line,i,j-i);
    	for (i=j+1; line[i]!='\"'; i++);
    	i++;
    	for (j=i; line[j]!='\"'; j++);
    	ficheroSalida[1] = new String (line,i,j-i);

        linea = lineasFichero.nextToken();
        tokens = new StringTokenizer (linea, "=");
        tokens.nextToken();
        seed = Long.parseLong(tokens.nextToken().substring(1));
        
        linea = lineasFichero.nextToken();
        tokens = new StringTokenizer (linea, "=");
        tokens.nextToken();
        C = Integer.parseInt(tokens.nextToken().substring(1));    
    }
}
